import { switchMap, take } from 'rxjs/operators';
import { Observable, of, throwError } from 'rxjs';
/**
 * @internal
 *
 * @param value
 * @param strategy
 * @param workFactory
 * @param options
 */
export function onStrategy(value, strategy, workFactory, options = {}) {
    let error;
    return new Observable(subscriber => {
        subscriber.next(value);
    }).pipe(strategy.behavior(() => {
        try {
            workFactory(value, strategy.work, options);
        }
        catch (e) {
            error = e;
        }
    }, options.scope || {}), switchMap(() => error ? throwError([error, value]) : of(value)), take(1));
}
//# sourceMappingURL=onStrategy.js.map